/* File: Prototypes.h */


/* AppleEventHandlers.c */
		char	 *OSTypeToPStr(OSType, char *);

		void 	InstallAppleEventHandlers(void);
pascal 	OSErr	NotHandled (AEDescList *aevt, AEDescList *reply, long refCon);
pascal 	OSErr 	HandleOapp (AEDescList *aevt, AEDescList *reply, long refCon);
pascal 	OSErr 	HandleQuit (AEDescList *aevt, AEDescList *reply, long refCon);
pascal 	OSErr 	HandleOdoc (AEDescList *aevt, AEDescList *reply, long refCon);
pascal 	OSErr 	HandlePdoc (AEDescList *aevt, AEDescList *reply, long refCon);

/* ErrorHandlers.c */
		void	Assert(Boolean condition, char *message, char *location, Boolean isFatal);
		Boolean AssertOK(Boolean condition, char *message, char *location);
		void	CheckPointer(void *p, char *ptrName, char *location);
		void	CheckHandle(void *h, char *handleName, char *location);
		void	CheckResult(short code, char *location);
		void	Error(char *errorMsg, char *location);
		Boolean IsValidPointer(void *p);
		Boolean IsValidHandle(void *h);
		void	ShowMessageAndDie(char *message);
		void	ShowMessage(char *message);

/* Interaction.c */
		OSErr 	MyInteractWithUser(Boolean isUrgent);

/* ==== misc (need to split) === */
		void 	ae_do_Quit (void);
		void 	ae_do_Close (void);
		void 	ae_do_Open (FSSpec *theFileSpec);
		void 	ae_do_NewDocument (void);

		void 	InvalidateWindow(WindowPtr whichWindow);
		void	EntryAdded (WindowPtr whichWindow, short entryNum);
		void	EntryRemoved (WindowPtr whichWindow, short entryNum);
		OSErr	NewScrapbookFile(FSSpec *theFile, Boolean *cancelled);
		void 	GoToEntry (WindowPtr whichWindow, short entryNum);
		void 	SetItemEnable (MenuHandle theMenu, short theItem, Boolean enabled);
		void 	EnableFileCommands (void);
		void 	AdjustMenus(void);
		void 	SetScrollMaxima (WindowPtr wp, wiHand info, Boolean setToZero);
		void 	SetControlPositions (WindowPtr wp, wiHand info);
		OSErr 	NewDisplayWindow (const FSSpec *);
		void 	CloseAWindow (WindowPtr whichWindow);
		void 	DoAppleCmds (short theItem);
		void 	DoFileCmds (short theItem);
		void 	DoScrapbookCmds (short theItem);
		void 	Dispatch (long menuResult);
		void	Init_all(void);
		void 	DoKey (EventRecord *theEvent);
		void 	DoUpdate (WindowPtr wp);
		void 	DoActivate (WindowPtr wp, Boolean activate);
		void 	DoContentClick (WindowPtr whichWindow, Point globalPt);
		void 	DoMouseDown (EventRecord *theEvent);
		void 	MainLoop(void);
		void 	Shutdown(void);
		void 	main(void);

/* string_util.c */
		void	PstringToText(const char *pstring, Handle *textBlock);
		void	CstringToText(const char *cstring, Handle *textBlock);
		void	TextToPstring(const Handle textBlock, char *pstring);
		void	TextToCstring(const Handle textBlock, char *cstring);

/* ScrapTools.c */
		OSErr 	_EntryToScrapIndex(short entryNum, short *scrapIndex, short *resID);
		OSErr 	_Get1ScrapItem(short, OSType, AEDesc *);
		OSErr 	CountScrapbookEntries(short *count);
		OSErr 	Get1ScrapbookItem (short index, OSType itemType, AEDesc *item);
		OSErr 	Put1ScrapbookItem (short entryIndex, const AEDescList *itemContents);
		OSErr	InsertScrapbookEntry (short entryNum, const AEDescList *itemList);
		OSErr 	_Delete1ScrapItem(short resID, OSType itemType);
		OSErr 	Delete1ScrapbookItem (short entryIndex, OSType itemType, Boolean *entryRemoved);
		OSErr 	AdjustScrapbookEntries(short startValue, Boolean adjustUpwards);
		OSErr 	ZeroScrapbookIndex(short smapIndex);
		OSErr	GetBestType(short entryNum, ResType *bestType);
		OSErr	GetAllTypes(short entryNum, short *numTypes, ResType *typeList);


/* cApplication.c */
		OSErr App_AE_Dispatcher(const AppleEvent *message, AppleEvent *reply, long refCon, AEEventClass classID, AEEventID eventID, const AEDesc *ospec, const AEDesc *token);
pascal	OSErr PropertyFromNullAccessor ( DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *returnedToken, long refCon );
		OSErr App_ReadTokenData(const AEDesc *theToken, AEDesc *tokenContents);
		OSErr App_WriteTokenData(const AEDesc *theToken, const AEDesc *data);
		OSErr App_GetData(AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr App_SetData(AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr App_InstallCallbacks( void );


/* cEntry.c */
pascal	OSErr 	EntryFromDocumentAccessor(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType form, const AEDesc *selectionData, AEDesc *value, long LongInt);
pascal	OSErr 	PropertyFromEntryAccessor ( DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *returnedToken, long refCon );
		OSErr 	Entry_ConvertAbsKey(const AEDesc *keyData, long *index, Boolean *getAll);
		OSErr 	Entry_ReadTokenData(const AEDesc *theToken, AEDesc *tokenContents);
		OSErr 	Entry_WriteTokenData(const AEDesc *theToken, const AEDesc *data);
		OSErr 	Entry_DeleteTokenData(const AEDesc *theToken);
		OSErr 	Entry_InsertTokenData(const AERecord *insertionLoc, const AEDescList *data, short *newElementNumber);
		OSErr 	Entry_GetData (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Entry_SetData (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Entry_CreateElement (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Entry_DeleteElement (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Entry_AE_Dispatcher(const AppleEvent *message, AppleEvent *reply, long refCon, AEEventClass classID, AEEventID eventID, const AEDesc *ospec, const AEDesc *token);


/* cScrapItem.c */
pascal	OSErr ItemFromEntryAccessor(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType form, const AEDesc *selectionData, AEDesc *value, long LongInt);
pascal	OSErr 	PropertyFromItemAccessor ( DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *returnedToken, long refCon );
		OSErr 	Item_ConvertAbsKey(const AEDesc *keyData, long *index, Boolean *getAll);
		OSErr 	Item_ReadTokenData(const AEDesc *theToken, AEDesc *tokenContents);
		OSErr 	Item_WriteTokenData(const AEDesc *theToken, const AEDesc *data);
		OSErr 	Item_DeleteTokenData(const AEDesc *theToken);
		OSErr 	Item_InsertTokenData(const AERecord *insertionLoc, const AEDescList *data, ResType *newTypeCode);
		OSErr 	Item_GetData (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Item_SetData (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Item_CreateElement (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Item_DeleteElement (AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Item_AE_Dispatcher(const AppleEvent *message, AppleEvent *reply, long refCon, AEEventClass classID, AEEventID eventID, const AEDesc *ospec, const AEDesc *token);

/* cWindow.c */
		OSErr 	Win_InstallCallbacks( void );
pascal	OSErr 	WindowFromNullAccessor(DescType desiredClass, const AEDesc *container, DescType containerClass, DescType form, const AEDesc *selectionData, AEDesc *value, long LongInt);
pascal	OSErr 	PropertyFromWindowAccessor ( DescType desiredClass, const AEDesc *container, DescType containerClass, DescType keyForm, const AEDesc *keyData, AEDesc *returnedToken, long refCon );
		long 	CountWindows(void);
		long 	GetWindowIndex(WindowPtr theWindow);
		WindowPtr FindIndexedWindow(long index);
		OSErr 	Win_ConvertAbsKey(const AEDesc *keyData, long *index, Boolean *getAll);
		void 	BuildWindowToken(const WindowPtr theWindow, DescType desiredClass, long index, AEDesc *theToken);
		OSErr 	Win_CreateElement(const AppleEvent *message, AppleEvent *reply, DescType insertionPos, AEDesc *token, AEDesc *replyObject);
		OSErr 	Win_Close(AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Win_GetData(AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Win_SetData(AppleEvent *message, AppleEvent *reply, long refcon, AEDesc *token, AEDesc *replyObject);
		OSErr 	Win_AE_Dispatcher(const AppleEvent *message, AppleEvent *reply, long refCon, AEEventClass classID, AEEventID eventID, const AEDesc *ospec, const AEDesc *token);
		OSErr 	Win_ReadTokenData(const AEDesc *theToken, AEDesc *tokenContents);
		OSErr 	Win_WriteTokenData(const AEDesc *theToken, const AEDesc *data);

/*  File: ObjectDispatch.proto.h */
		OSErr 	SendAEToObject (	const AppleEvent *message, AppleEvent *reply, long refCon, AEEventClass classID, AEEventID eventID, DescType dispatchClass, const AEDesc *ospec, const AEDesc *token);
pascal 	OSErr 	DirectParamDispatch(AppleEvent *message, AppleEvent *reply, long refcon);
pascal 	OSErr 	CreateElementDispatch(AppleEvent *message, AppleEvent *reply, long refcon);

